/////////////////////////////////////////////////////////////////////////////
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// MenuExtension.h :gVF ReNXgj[R|[lgNX̃wb_
//					LhaForgegj[
//
//	Original File Information:
// MenuExtension.h :gVF ReNXgj[R|[lgNX̃wb_
//					l(TF)gj[
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ConfigManager.h"

const int PARAM_MAX_LEN=256;


// ReNXgj[R|[lg̍쐬iIShellExtInit,IContextMenu𑽏dpj
class CMenuExtension : public IShellExtInit,public IContextMenu
{
protected:
	//bool			m_bXP;					//WindowsXP͂ȍ~Ȃtrue
	LONG			m_cRef;					// IuWFNg̎QƃJEg
	bool			m_bMenuAdded;			//j[ǉς݂Ȃtrue

	std::vector<CString> m_SelFileArray;	// It@Ce[u
	CString			m_strTargetFolder;			//hbÕtH_

	std::vector<CString> m_CmdParamArray;	//R}hp[^̔z;j[ID11Ή

	CConfigManager	m_Config;
	bool			m_bRightDrag;				//EhbOǂ;CLSIDŕނAClassFactoryŌ܂
	bool			m_bForceExtraMenu;			//gj[(SHIFT+ENbN/hbO)ǂ
	std::vector<HMENU>	m_MenuHandleList;		//|bvAbvj[̃nhǗ
protected:
	void PrepareMenu();			// j[̏
	bool GetSelectedFiles(LPDATAOBJECT pDataObj);			// It@Co
	void DeleteMenuData();		// j[f[^̔j
	void DoCommand(UINT inIdx);	// Igj[̃R}hs

	HMENU MakePopupMenuItem();
	void AddDummyMenuCommand(){m_CmdParamArray.push_back(_T(""));}

	void BuildExtraMenu(HMENU hParentMenu,UINT idCmdFirst,int menuIdx,const SHELL_MENU_ITEM* pMenu,size_t numItems);
	void InsertCommandMenuItems(HMENU hParentMenu,UINT idCmdFirst,const SHELL_MENU_ITEM* pMenu,size_t numItems,int nOffset);

	UINT InsertContextMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst,BOOL bInSubMenu);	//j[ǉ

	UINT InsertCompressMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);	//indexMenu+(߂l)indexMenu
	UINT InsertExtractMenuRClick(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);
	UINT InsertExtractMenuRDrag(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);
	UINT InsertOperationMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);
	UINT InsertXacRettMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);
	UINT InsertB2EMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);
	UINT InsertUserMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst);
public:
	// RXgN^EfXgN^
	CMenuExtension(bool);
	virtual ~CMenuExtension();

	// IUnknown C^[tFCX̃\bh
	STDMETHODIMP            QueryInterface(REFIID, LPVOID *);
	STDMETHODIMP_(ULONG)    AddRef();
	STDMETHODIMP_(ULONG)    Release();

	// IShellExtInit C^[tFCX̃\bh
	STDMETHODIMP Initialize(LPCITEMIDLIST pIDFolder, LPDATAOBJECT pDataObj, HKEY hKeyID);

	// IContextMenu C^[tFCX̃\bh
	STDMETHODIMP QueryContextMenu(HMENU hMenu, UINT indexMenu, UINT idCmdFirst,UINT idCmdLast, UINT uFlags);
	STDMETHODIMP InvokeCommand(LPCMINVOKECOMMANDINFO lpcmi);
	STDMETHODIMP GetCommandString(UINT_PTR idCmd, UINT uType, UINT* pwReserved,LPSTR pszName, UINT cchMax);
};


